"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = lane;

function _constants() {
  const data = require("../../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _lanesIsDisabled() {
  const data = require("../../../consumer/lanes/exceptions/lanes-is-disabled");

  _lanesIsDisabled = function () {
    return data;
  };

  return data;
}

function _getRemoteByName() {
  const data = _interopRequireDefault(require("../../../remotes/get-remote-by-name"));

  _getRemoteByName = function () {
    return data;
  };

  return data;
}

async function lane({
  name,
  remote,
  merged,
  showDefaultLane,
  notMerged
}) {
  const showMergeData = Boolean(merged || notMerged);

  if (remote) {
    const consumer = await (0, _consumer().loadConsumerIfExist)();
    if (consumer && consumer.isLegacy) throw new (_lanesIsDisabled().LanesIsDisabled)();
    const remoteObj = await (0, _getRemoteByName().default)(remote, consumer);
    const lanes = await remoteObj.listLanes(name, showMergeData);
    return {
      lanes
    };
  }

  const consumer = await (0, _consumer().loadConsumer)();
  if (consumer.isLegacy) throw new (_lanesIsDisabled().LanesIsDisabled)();
  const lanes = await consumer.scope.lanes.getLanesData(consumer.scope, name, showMergeData);

  if (showDefaultLane) {
    lanes.push(getLaneDataOfDefaultLane());
  }

  const currentLane = consumer.scope.lanes.getCurrentLaneName();
  return {
    lanes,
    currentLane
  };

  function getLaneDataOfDefaultLane() {
    const bitIds = consumer.bitMap.getAuthoredAndImportedBitIdsOfDefaultLane();
    return {
      name: _constants().DEFAULT_LANE,
      remote: null,
      components: bitIds.map(bitId => ({
        id: bitId,
        head: bitId.version
      })),
      isMerged: null
    };
  }
}