"use strict";

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = linkAction;

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _codemodComponents() {
  const data = require("../../../consumer/component-ops/codemod-components");

  _codemodComponents = function () {
    return data;
  };

  return data;
}

function _links() {
  const data = require("../../../links");

  _links = function () {
    return data;
  };

  return data;
}

async function linkAction(ids, changeRelativeToModulePaths, runOnConsumerDestroy = true) {
  const consumer = await (0, _consumer().loadConsumer)();
  const bitIds = ids.map(id => consumer.getParsedId(id));
  let codemodResults;

  if (changeRelativeToModulePaths) {
    codemodResults = await (0, _codemodComponents().changeCodeFromRelativeToModulePaths)(consumer, bitIds);
  }

  const linksResults = await (0, _links().linkAllToNodeModules)(consumer, bitIds);
  if (runOnConsumerDestroy) await consumer.onDestroy();
  return {
    linksResults,
    codemodResults
  };
}