"use strict";

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _moveComponents() {
  const data = require("../../../consumer/component-ops/move-components");

  _moveComponents = function () {
    return data;
  };

  return data;
}

var move = async function move({
  from,
  to,
  component
}) {
  const consumer = await (0, _consumer().loadConsumer)();
  let moveResults;

  if (component) {
    const id = consumer.getParsedId(from);
    moveResults = await (0, _moveComponents().moveExistingComponentFilesToOneDir)(consumer, id, to);
  } else {
    moveResults = await (0, _moveComponents().movePaths)(consumer, {
      from,
      to
    });
  }

  await consumer.onDestroy();
  return moveResults;
};

exports.default = move;