"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _scope() {
  const data = require("../../../scope");

  _scope = function () {
    return data;
  };

  return data;
}

function _scopeGraph() {
  const data = _interopRequireDefault(require("../../../scope/graph/scope-graph"));

  _scopeGraph = function () {
    return data;
  };

  return data;
}

var graph = async function graph(path, id) {
  const scope = await (0, _scope().loadScope)(path);
  const dependencyGraph = await _scopeGraph().default.loadLatest(scope);

  if (!id) {
    return dependencyGraph.serialize();
  }

  const bitId = await scope.getParsedId(id);
  const componentGraph = dependencyGraph.getSubGraphOfConnectedComponents(bitId);
  return dependencyGraph.serialize(componentGraph);
};

exports.default = graph;