import { AllDependencies, AllPackagesDependencies, Issues } from './dependencies-resolver';
import { ManuallyChangedDependencies } from './overrides-dependencies';
export declare type OverridesDependenciesData = {
    manuallyRemovedDependencies: ManuallyChangedDependencies;
    manuallyAddedDependencies: ManuallyChangedDependencies;
    missingPackageDependencies: string[];
};
export declare class DependenciesData {
    allDependencies: AllDependencies;
    allPackagesDependencies: AllPackagesDependencies;
    issues: Issues;
    coreAspects: string[];
    overridesDependencies: OverridesDependenciesData;
    constructor(allDependencies: AllDependencies, allPackagesDependencies: AllPackagesDependencies, issues: Issues, coreAspects: string[], overridesDependencies: OverridesDependenciesData);
    serialize(): string;
    static deserialize(data: string): DependenciesData;
}
