"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DependenciesData = void 0;

function _bitId() {
  const data = require("../../../../bit-id");

  _bitId = function () {
    return data;
  };

  return data;
}

function _dependency() {
  const data = _interopRequireDefault(require("../dependency"));

  _dependency = function () {
    return data;
  };

  return data;
}

class DependenciesData {
  constructor(allDependencies, allPackagesDependencies, issues, coreAspects, overridesDependencies) {
    this.allDependencies = allDependencies;
    this.allPackagesDependencies = allPackagesDependencies;
    this.issues = issues;
    this.coreAspects = coreAspects;
    this.overridesDependencies = overridesDependencies;
  }

  serialize() {
    return JSON.stringify(this);
  }

  static deserialize(data) {
    const dataParsed = JSON.parse(data);
    const dependencies = dataParsed.allDependencies.dependencies.map(dep => new (_dependency().default)(new (_bitId().BitId)(dep.id), dep.relativePaths, dep.packageName));
    const devDependencies = dataParsed.allDependencies.devDependencies.map(dep => new (_dependency().default)(new (_bitId().BitId)(dep.id), dep.relativePaths, dep.packageName));
    const issues = deserializeIssues(dataParsed.issues);
    const allDependencies = {
      dependencies,
      devDependencies
    };
    return new DependenciesData(allDependencies, dataParsed.allPackagesDependencies, issues, dataParsed.coreAspects, dataParsed.overridesDependencies);
  }

}

exports.DependenciesData = DependenciesData;

function deserializeIssues(issues) {
  if (!issues) return {};

  if (issues.relativeComponentsAuthored) {
    Object.keys(issues.relativeComponentsAuthored).forEach(fileName => {
      issues.relativeComponentsAuthored[fileName] = issues.relativeComponentsAuthored[fileName].map(record => ({
        importSource: record.importSource,
        componentId: new (_bitId().BitId)(record.componentId),
        relativePath: record.relativePath
      }));
    });
  }

  const fields = ['relativeComponents', 'missingComponents', 'missingLinks'];
  fields.forEach(field => {
    if (!issues[field]) return;
    Object.keys(issues[field]).forEach(filePath => {
      issues[field][filePath] = issues[field][filePath].map(id => new (_bitId().BitId)(id));
    });
  });
  return issues;
}