export declare type FileContext = {
    ext: string;
};
export declare type DependencyContext = {
    filepath: string;
    ext: string;
    content?: string;
};
export interface DependencyDetector {
    isSupported(context: FileContext): boolean;
    detect(fileContent: string): string[];
    dependencyLookup?(file: DependencyContext): string;
}
export declare class DetectorHook {
    static hooks: DependencyDetector[];
    isSupported(ext: string): boolean;
    getDetector(ext: string): DependencyDetector | undefined;
}
