"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _npmClient() {
  const data = _interopRequireDefault(require("../../npm-client"));

  _npmClient = function () {
    return data;
  };

  return data;
}

function _diagnosis() {
  const data = _interopRequireDefault(require("../diagnosis"));

  _diagnosis = function () {
    return data;
  };

  return data;
}

class ValidateYarnExec extends _diagnosis().default {
  constructor(...args) {
    super(...args);
    (0, _defineProperty2().default)(this, "name", 'validate yarn exec');
    (0, _defineProperty2().default)(this, "description", 'validate that yarn executable found');
    (0, _defineProperty2().default)(this, "category", 'vendors');
  }

  _formatSymptoms() {
    return 'yarn executable not found';
  }

  _formatManualTreat() {
    return 'please ensure yarn is installed';
  }

  async _runExamine() {
    const yarnVersion = await _npmClient().default.getYarnVersion();

    if (yarnVersion) {
      return {
        valid: true
      };
    }

    return {
      valid: false,
      data: {}
    };
  }

}

exports.default = ValidateYarnExec;