"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parse;

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _jsdoc() {
  const data = _interopRequireDefault(require("./jsdoc"));

  _jsdoc = function () {
    return data;
  };

  return data;
}

function _react() {
  const data = _interopRequireDefault(require("./react"));

  _react = function () {
    return data;
  };

  return data;
}

function _vue() {
  const data = _interopRequireDefault(require("./vue"));

  _vue = function () {
    return data;
  };

  return data;
}

async function parse(file, componentFsCache) {
  const docsFromCache = await componentFsCache.getDocsFromCache(file.path);

  if (docsFromCache && docsFromCache.timestamp) {
    const stat = await _fsExtra().default.stat(file.path);
    const wasFileChanged = stat.mtimeMs > docsFromCache.timestamp;

    if (!wasFileChanged) {
      return JSON.parse(docsFromCache.data);
    }
  }

  const results = await parseFile(file.contents.toString(), file.relative);
  await componentFsCache.saveDocsInCache(file.path, results);
  return results;
}

async function parseFile(data, filePath) {
  if ((0, _utils().getExt)(filePath) === 'vue') {
    return (0, _vue().default)(data, filePath);
  }

  const reactDocs = await (0, _react().default)(data, filePath);

  if (reactDocs && Object.keys(reactDocs).length > 0) {
    return reactDocs;
  }

  return (0, _jsdoc().default)(data, filePath);
}