"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Profiler = void 0;

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

class Profiler {
  constructor() {
    (0, _defineProperty2().default)(this, "profilers", {});
  }

  profile(id) {
    if (!this.profilers[id]) this.profilers[id] = {};
    const currentProfiler = this.profilers[id];
    const now = Date.now();

    if (currentProfiler.current) {
      const sinceLastCall = now - currentProfiler.current;
      const total = currentProfiler.total ? currentProfiler.total + sinceLastCall : sinceLastCall;
      currentProfiler.total = total;
      delete currentProfiler.current;
      return `${sinceLastCall}ms. (total repeating ${total}ms)`;
    }

    currentProfiler.current = now;
    return '';
  }

}

exports.Profiler = Profiler;