import { BitId, BitIds } from '../../bit-id';
import { Lane, Version } from '../models';
import Scope from '../scope';
import { ObjectList } from '../objects/object-list';
export declare type OnExportIdTransformer = (id: BitId) => BitId;
declare type UpdateDependenciesOnExportFunc = (version: Version, idTransformer: OnExportIdTransformer) => Version;
export declare function registerUpdateDependenciesOnExport(func: UpdateDependenciesOnExportFunc): void;
export declare function exportManyBareScope(scope: Scope, objectList: ObjectList): Promise<BitIds>;
export declare function exportMany({ scope, isLegacy, ids, remoteName, context, includeDependencies, changeLocallyAlthoughRemoteIsDifferent, codemod, lanesObjects, allVersions, idsWithFutureScope, resumeExportId, }: {
    scope: Scope;
    isLegacy: boolean;
    ids: BitIds;
    remoteName: string | null | undefined;
    context?: Record<string, any>;
    includeDependencies: boolean;
    changeLocallyAlthoughRemoteIsDifferent: boolean;
    codemod: boolean;
    lanesObjects?: Lane[];
    allVersions: boolean;
    idsWithFutureScope: BitIds;
    resumeExportId?: string | undefined;
}): Promise<{
    exported: BitIds;
    updatedLocally: BitIds;
    newIdsOnRemote: BitId[];
}>;
export declare function mergeObjects(scope: Scope, objectList: ObjectList, throwForMissingDeps?: boolean): Promise<BitIds>;
export declare function resumeExport(scope: Scope, exportId: string, remotes: string[]): Promise<string[]>;
export {};
