import { Scope } from '..';
import { BitId, BitIds } from '../../bit-id';
import ConsumerComponent from '../../consumer/component';
import { RemoteLaneId } from '../../lane-id/lane-id';
import ComponentVersion, { ObjectCollector } from '../component-version';
import { Lane, ModelComponent } from '../models';
import { Repository } from '../objects';
import { ObjectItem } from '../objects/object-list';
import SourcesRepository from '../repositories/sources';
import VersionDependencies from '../version-dependencies';
export default class ScopeComponentsImporter {
    scope: Scope;
    sources: SourcesRepository;
    repo: Repository;
    constructor(scope: Scope);
    static getInstance(scope: Scope): ScopeComponentsImporter;
    importMany(ids: BitIds, cache?: boolean, persist?: boolean, throwForDependencyNotFound?: boolean): Promise<VersionDependencies[]>;
    importManyFromOriginalScopes(ids: BitIds): Promise<VersionDependencies[]>;
    importWithoutDeps(ids: BitIds, cache?: boolean): Promise<ComponentVersion[]>;
    importManyWithAllVersions(ids: BitIds, cache?: boolean, allDepsVersions?: boolean): Promise<VersionDependencies[]>;
    importManyDeltaWithoutDeps(ids: BitIds): Promise<void>;
    importFromLanes(remoteLaneIds: RemoteLaneId[]): Promise<Lane[]>;
    importLanes(remoteLaneIds: RemoteLaneId[]): Promise<Lane[]>;
    importManyObjects(groupedHashes: {
        [scopeName: string]: string[];
    }): Promise<void>;
    fetchWithoutDeps(ids: BitIds): Promise<ComponentVersion[]>;
    fetchWithDeps(ids: BitIds): Promise<VersionDependencies[]>;
    componentToVersionDependencies(component: ModelComponent, id: BitId, throwForNoVersion?: boolean): Promise<VersionDependencies | null>;
    componentsToComponentsObjects(components: ObjectCollector[], clientVersion: string | null | undefined, collectParents: boolean, collectArtifacts: boolean): Promise<ObjectItem[]>;
    loadRemoteComponent(id: BitId): Promise<ConsumerComponent>;
    loadComponent(id: BitId, localOnly?: boolean): Promise<ConsumerComponent>;
    private getVersionFromComponentDef;
    private getExternalMany;
    private getExternal;
    private getExternalWithoutDependencies;
    private getExternalManyWithoutDeps;
    private _getComponentVersion;
    private findMissingExternalsRecursively;
    private bitIdsToVersionDeps;
    private throwIfExternalFound;
}
