import { ReleaseType } from 'semver';
import { Scope } from '..';
import { BitId } from '../../bit-id';
import Component from '../../consumer/component/consumer-component';
import Consumer from '../../consumer/consumer';
import { AutoTagResult } from './auto-tag';
import { LegacyOnTagResult } from '../scope';
import { BasicTagParams } from '../../api/consumer/lib/tag';
export declare type onTagIdTransformer = (id: BitId) => BitId | null;
declare type UpdateDependenciesOnTagFunc = (component: Component, idTransformer: onTagIdTransformer) => Component;
export declare function registerUpdateDependenciesOnTag(func: UpdateDependenciesOnTagFunc): void;
export default function tagModelComponent({ consumerComponents, scope, message, exactVersion, releaseType, force, consumer, ignoreNewestVersion, skipTests, verbose, skipAutoTag, soft, build, persist, resolveUnmerged, isSnap, disableDeployPipeline, }: {
    consumerComponents: Component[];
    scope: Scope;
    exactVersion?: string | null | undefined;
    releaseType?: ReleaseType;
    consumer: Consumer;
    resolveUnmerged?: boolean;
    isSnap?: boolean;
} & BasicTagParams): Promise<{
    taggedComponents: Component[];
    autoTaggedResults: AutoTagResult[];
    publishedPackages: string[];
}>;
export declare function addFlattenedDependenciesToComponents(scope: Scope, components: Component[]): Promise<void>;
export declare function updateComponentsByTagResult(components: Component[], tagResult: LegacyOnTagResult[]): void;
export declare function getPublishedPackages(components: Component[]): string[];
export {};
