import { BitId, BitIds } from '../bit-id';
import ConsumerComponent from '../consumer/component';
import { ManipulateDirItem } from '../consumer/component-ops/manipulate-dir';
import ModelComponent from './models/model-component';
import Version from './models/version';
import { Ref } from './objects';
import { ObjectItem } from './objects/object-list';
import Repository from './objects/repository';
export default class ComponentVersion implements ObjectCollector {
    readonly component: ModelComponent;
    readonly version: string;
    constructor(component: ModelComponent, version: string);
    getVersion(repository: Repository, throws?: boolean): Promise<Version>;
    flattenedDependencies(repository: Repository): Promise<BitIds>;
    toId(): BitId;
    get id(): BitId;
    toConsumer(repo: Repository, manipulateDirData: ManipulateDirItem[] | null | undefined): Promise<ConsumerComponent>;
    collectObjects(repo: Repository, clientVersion: string | null | undefined, options: CollectObjectsOpts): Promise<ObjectItem[]>;
}
export interface ObjectCollector {
    collectObjects(repo: Repository, clientVersion: string | null | undefined, options: CollectObjectsOpts): Promise<ObjectItem[]>;
}
export declare type CollectObjectsOpts = {
    collectParents: boolean;
    collectParentsUntil?: Ref | null;
    collectArtifacts: boolean;
};
