"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PersistFailed = void 0;

function _bitError() {
  const data = require("@teambit/bit-error");

  _bitError = function () {
    return data;
  };

  return data;
}

class PersistFailed extends _bitError().BitError {
  constructor(failedScope, persistedScopes, notPersistedScopes, clientId, errorMsg, triggeredByResumeExportCmd) {
    const resumeFlagSuggestion = `you can resume the export by re-running the same export command with the suffix: "--resume ${clientId}".`;
    const resumeExportSuggestion = `you can re-try running resume-export command with the non-persisted scopes.`;
    super(`fatal: export failed during the persist phase of "${failedScope}", with the error "${errorMsg}", see the log for the error details.
the following scopes were persisted successfully: ${persistedScopes.length ? persistedScopes.join(', ') : '<none>'}.
the following scopes were not persisted yet: ${notPersistedScopes.length ? notPersistedScopes.join(', ') : '<none>'}.

${triggeredByResumeExportCmd ? resumeExportSuggestion : resumeFlagSuggestion}
`);
  }

}

exports.PersistFailed = PersistFailed;