"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bitError() {
  const data = require("@teambit/bit-error");

  _bitError = function () {
    return data;
  };

  return data;
}

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function () {
    return data;
  };

  return data;
}

class VersionNotFound extends _bitError().BitError {
  constructor(version, componentId, onFs = false) {
    super(`error: version "${_chalk().default.bold(version)}"${componentId ? ` of component ${_chalk().default.bold(componentId)}` : ''} was not found${onFs ? ' on the filesystem' : ''}.`);
    this.version = version;
    this.componentId = componentId;
    this.onFs = onFs;
  }

}

exports.default = VersionNotFound;