"use strict";

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.flattenDependencies = flattenDependencies;
exports.flattenDependencyIds = flattenDependencyIds;

function _bitId() {
  const data = require("../bit-id");

  _bitId = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function flattenDependencies(dependencies) {
  return Object.values((0, _utils().flatten)(dependencies.map(dep => dep.allDependencies.concat(dep.component))).reduce((components, component) => {
    components[component.id.toString()] = component;
    return components;
  }, {}));
}

async function flattenDependencyIds(dependencies, repo) {
  const ids = await Promise.all(dependencies.map(dep => {
    const depCompId = dep.component.id.changeScope(dep.sourceScope);
    return dep.component.flattenedDependencies(repo).then(flattenedDeps => flattenedDeps.concat(depCompId));
  }));
  const flattenedIds = (0, _utils().flatten)(ids);
  return _bitId().BitIds.uniqFromArray(flattenedIds);
}