"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

async function readKey(keyPath) {
  if (!keyPath) return '';

  try {
    const fileBuffer = await _fsExtra().default.readFile(keyPath);
    return fileBuffer;
  } catch (e) {
    return '';
  }
}

var keyGetter = async function keyGetter(keyPath) {
  if (keyPath) return readKey(keyPath);
  const sshFile = await (0, _utils().identityFile)();

  _logger().default.debug(`ssh, reading ssh key at ${sshFile}`);

  return readKey(sshFile);
};

exports.default = keyGetter;