"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator.js");

require("core-js/modules/es.promise.js");

require("core-js/modules/es.string.replace.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _lodash() {
  const data = require("lodash");

  _lodash = function () {
    return data;
  };

  return data;
}

function path() {
  const data = _interopRequireWildcard(require("path"));

  path = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _pMap() {
  const data = _interopRequireDefault(require("p-map"));

  _pMap = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _fsRemoveFile() {
  const data = _interopRequireDefault(require("../../utils/fs-remove-file"));

  _fsRemoveFile = function () {
    return data;
  };

  return data;
}

function _exceptions() {
  const data = require("../exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

function _remoteLanes() {
  const data = _interopRequireDefault(require("../lanes/remote-lanes"));

  _remoteLanes = function () {
    return data;
  };

  return data;
}

function _unmergedComponents() {
  const data = _interopRequireDefault(require("../lanes/unmerged-components"));

  _unmergedComponents = function () {
    return data;
  };

  return data;
}

function _scopeMeta() {
  const data = _interopRequireDefault(require("../models/scopeMeta"));

  _scopeMeta = function () {
    return data;
  };

  return data;
}

function _componentsIndex() {
  const data = _interopRequireDefault(require("./components-index"));

  _componentsIndex = function () {
    return data;
  };

  return data;
}

function _object() {
  const data = _interopRequireDefault(require("./object"));

  _object = function () {
    return data;
  };

  return data;
}

function _objectList() {
  const data = require("./object-list");

  _objectList = function () {
    return data;
  };

  return data;
}

function _rawObject() {
  const data = _interopRequireDefault(require("./raw-object"));

  _rawObject = function () {
    return data;
  };

  return data;
}

function _ref() {
  const data = _interopRequireDefault(require("./ref"));

  _ref = function () {
    return data;
  };

  return data;
}

function _repositoryHooks() {
  const data = require("./repository-hooks");

  _repositoryHooks = function () {
    return data;
  };

  return data;
}

const OBJECTS_BACKUP_DIR = `${_constants().OBJECTS_DIR}.bak`;

class Repository {
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  constructor(scopePath, scopeJson) {
    (0, _defineProperty2().default)(this, "objects", {});
    (0, _defineProperty2().default)(this, "objectsToRemove", []);
    (0, _defineProperty2().default)(this, "scopeJson", void 0);
    (0, _defineProperty2().default)(this, "onRead", void 0);
    (0, _defineProperty2().default)(this, "onPersist", void 0);
    (0, _defineProperty2().default)(this, "scopePath", void 0);
    (0, _defineProperty2().default)(this, "scopeIndex", void 0);
    (0, _defineProperty2().default)(this, "_cache", {});
    (0, _defineProperty2().default)(this, "remoteLanes", void 0);
    (0, _defineProperty2().default)(this, "unmergedComponents", void 0);
    this.scopePath = scopePath;
    this.scopeJson = scopeJson;
    this.onRead = (0, _repositoryHooks().onRead)(scopePath, scopeJson);
    this.onPersist = (0, _repositoryHooks().onPersist)(scopePath, scopeJson);
  }

  static async load({
    scopePath,
    scopeJson
  }) {
    const repository = new Repository(scopePath, scopeJson);
    const scopeIndex = await repository.loadOptionallyCreateScopeIndex();
    repository.scopeIndex = scopeIndex;
    repository.remoteLanes = new (_remoteLanes().default)(scopePath);
    repository.unmergedComponents = await _unmergedComponents().default.load(scopePath);
    return repository;
  }

  static create({
    scopePath,
    scopeJson
  }) {
    const repository = new Repository(scopePath, scopeJson);

    const scopeIndex = _componentsIndex().default.create(scopePath);

    repository.scopeIndex = scopeIndex;
    return repository;
  }

  static reset(scopePath) {
    return _componentsIndex().default.reset(scopePath);
  }

  static getPathByScopePath(scopePath) {
    return path().join(scopePath, _constants().OBJECTS_DIR);
  }

  ensureDir() {
    return _fsExtra().default.ensureDir(this.getPath());
  }

  getPath() {
    return Repository.getPathByScopePath(this.scopePath);
  }

  getBackupPath(dirName) {
    const backupPath = path().join(this.scopePath, OBJECTS_BACKUP_DIR);
    return dirName ? path().join(backupPath, dirName) : backupPath;
  }

  getLicense() {
    // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
    return this.scopeJson.getPopulatedLicense();
  }

  async getScopeMetaObject() {
    const license = await this.getLicense();

    const object = _scopeMeta().default.fromObject({
      license,
      name: this.scopeJson.name
    });

    return {
      ref: object.hash(),
      buffer: await object.compress()
    };
  }

  objectPath(ref) {
    return path().join(this.getPath(), this.hashPath(ref));
  }

  async has(ref) {
    const objectPath = this.objectPath(ref);
    return _fsExtra().default.pathExists(objectPath);
  }

  async load(ref, throws = false) {
    const cached = this.getCache(ref);

    if (cached) {
      return cached;
    } // @ts-ignore @todo: fix! it should return BitObject | null.


    return _fsExtra().default.readFile(this.objectPath(ref)).then(fileContents => {
      return this.onRead(fileContents);
    }).then(fileContents => {
      return _object().default.parseObject(fileContents);
    }).then(parsedObject => {
      this.setCache(parsedObject);
      return parsedObject;
    }).catch(err => {
      if (err.code !== 'ENOENT') {
        _logger().default.error(`Failed reading a ref file ${this.objectPath(ref)}. Error: ${err.message}`);

        throw err;
      }

      _logger().default.trace(`Failed finding a ref file ${this.objectPath(ref)}.`);

      if (throws) throw err;
      return null;
    });
  }

  async list() {
    const refs = await this.listRefs();
    return Promise.all(refs.map(ref => this.load(ref)));
  }

  async listRefs(cwd = this.getPath()) {
    const matches = await (0, _utils().glob)(path().join('*', '*'), {
      cwd
    });
    const refs = matches.map(str => {
      const hash = str.replace(path().sep, '');
      return new (_ref().default)(hash);
    });
    return refs;
  }

  async listRawObjects() {
    const refs = await this.listRefs();
    return Promise.all(refs.map(async ref => {
      try {
        const buffer = await this.loadRaw(ref);
        const bitRawObject = await _rawObject().default.fromDeflatedBuffer(buffer, ref.hash);
        return bitRawObject;
      } catch (err) {
        _logger().default.error(`Couldn't load the ref ${ref} this object is probably corrupted and should be delete`);

        return null;
      }
    }));
  }

  async listObjectsFromIndex(indexType, filter) {
    const hashes = filter ? this.scopeIndex.getHashesByQuery(indexType, filter) : this.scopeIndex.getHashes(indexType);
    return this._getBitObjectsByHashes(hashes);
  }

  getHashFromIndex(indexType, filter) {
    const hashes = this.scopeIndex.getHashesByQuery(indexType, filter);
    if (hashes.length > 2) throw new Error('getHashFromIndex expect to get zero or one result');
    return hashes.length ? hashes[0] : null;
  }

  async _getBitObjectsByHashes(hashes) {
    const bitObjects = await Promise.all(hashes.map(async hash => {
      const bitObject = await this.load(new (_ref().default)(hash));

      if (!bitObject) {
        const indexJsonPath = this.scopeIndex.getPath();

        if (this.scopeIndex.isFileOnBitHub()) {
          _logger().default.error(`repository._getBitObjectsByHashes, indexJson at "${indexJsonPath}" is outdated and needs to be deleted`);

          return null;
        }

        const indexItem = this.scopeIndex.find(hash);
        if (!indexItem) throw new Error(`_getBitObjectsByHashes failed finding ${hash}`);
        await this.scopeIndex.deleteFile(); // @ts-ignore componentId must be set as it was retrieved from indexPath before

        throw new (_exceptions().OutdatedIndexJson)(indexItem.toIdentifierString(), indexJsonPath);
      }

      return bitObject;
    })); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    return bitObjects.filter(b => b); // remove nulls;
  }

  async loadOptionallyCreateScopeIndex() {
    try {
      const scopeIndex = await _componentsIndex().default.load(this.scopePath);
      return scopeIndex;
    } catch (err) {
      if (err.code === 'ENOENT') {
        const bitObjects = await this.list();

        const scopeIndex = _componentsIndex().default.create(this.scopePath);

        const added = scopeIndex.addMany(bitObjects);
        if (added) await scopeIndex.write();
        return scopeIndex;
      }

      throw err;
    }
  }

  async loadRaw(ref) {
    const raw = await _fsExtra().default.readFile(this.objectPath(ref)); // Run hook to transform content pre reading

    const transformedContent = this.onRead(raw);
    return transformedContent;
  }

  async loadRawObject(ref) {
    const buffer = await this.loadRaw(ref);
    const bitRawObject = await _rawObject().default.fromDeflatedBuffer(buffer, ref.hash);
    return bitRawObject;
  }
  /**
   * prefer using `this.load()` for an async version, which also writes to the cache
   */


  loadSync(ref, throws = true) {
    try {
      const objectFile = _fsExtra().default.readFileSync(this.objectPath(ref)); // Run hook to transform content pre reading


      const transformedContent = this.onRead(objectFile);
      return _object().default.parseSync(transformedContent);
    } catch (err) {
      if (throws) {
        throw new (_exceptions().HashNotFound)(ref.toString());
      } // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!


      return null;
    }
  }

  setCache(object) {
    this._cache[object.hash().toString()] = object;
    return this;
  }

  getCache(ref) {
    return this._cache[ref.toString()];
  }

  removeFromCache(ref) {
    delete this._cache[ref.toString()];
  }

  clearCache() {
    _logger().default.debug('repository.clearCache');

    this._cache = {};
  }

  backup(dirName) {
    const backupDir = this.getBackupPath(dirName);
    const objectsDir = this.getPath();

    _logger().default.debug(`making a backup of all objects from ${objectsDir} to ${backupDir}`);

    _fsExtra().default.emptyDirSync(backupDir);

    _fsExtra().default.copySync(objectsDir, backupDir);
  }

  add(object) {
    if (!object) return this; // leave the following commented log message, it is very useful for debugging but too verbose when not needed.
    // logger.debug(`repository: adding object ${object.hash().toString()} which consist of the following id: ${object.id()}`);

    this.objects[object.hash().toString()] = object;
    this.setCache(object);
    return this;
  }

  addMany(objects) {
    if (!objects || !objects.length) return this;
    objects.forEach(obj => this.add(obj));
    return this;
  }

  removeObject(ref) {
    this.objectsToRemove.push(ref);
  }

  removeManyObjects(refs) {
    if (!refs || !refs.length) return;
    refs.forEach(ref => this.removeObject(ref));
  }

  findMany(refs) {
    return Promise.all(refs.map(ref => this.load(ref)));
  }
  /**
   * persist objects changes (added and removed) into the filesystem
   * do not call this function multiple times in parallel, otherwise, it'll damage the index.json file.
   * call this function only once after you added and removed all applicable objects.
   */


  async persist(validate = true) {
    _logger().default.debug(`Repository.persist, validate = ${validate.toString()}`);

    await this._deleteMany();

    this._validateObjects(validate);

    await this._writeMany();
    await this.remoteLanes.write();
    await this.unmergedComponents.write();
    this.clearObjects();

    if (Repository.onPostObjectsPersist) {
      Repository.onPostObjectsPersist().catch(err => {
        _logger().default.error('fatal: onPostObjectsPersist encountered an error (this error does not stop the process)', err);
      });
    }
  }
  /**
   * this is especially critical for http server, where one process lives long and serves multiple
   * exports. without this, the objects get accumulated over time and being rewritten over and over
   * again.
   */


  clearObjects() {
    this.objects = {};
    this.objectsToRemove = [];
  }
  /**
   * normally, the validation step takes place just before the acutal writing of the file.
   * however, this can be an issue where a component has an invalid version. the component could
   * be saved before validating the version (see #1727). that's why we validate here before writing
   * anything to the filesystem.
   * the open question here is whether should we validate again before the actual writing or it
   * should be enough to validate here?
   * for now, it does validate again before saving, only to be 100% sure nothing happens in a few
   * lines of code until the actual writing. however, if the performance penalty is noticeable, we
   * can easily revert it by changing `bitObject.validateBeforePersist = false` line run regardless
   * the `validate` argument.
   */


  _validateObjects(validate) {
    Object.keys(this.objects).forEach(hash => {
      const bitObject = this.objects[hash]; // @ts-ignore some BitObject classes have validate() method

      if (validate && bitObject.validate) {
        // @ts-ignore
        bitObject.validate();
      }

      if (!validate) {
        bitObject.validateBeforePersist = false;
      }
    });
  }

  async _deleteMany() {
    if (!this.objectsToRemove.length) return;
    const uniqRefs = (0, _lodash().uniqBy)(this.objectsToRemove, 'hash');

    _logger().default.debug(`Repository._deleteMany: deleting ${uniqRefs.length} objects`);

    await (0, _pMap().default)(uniqRefs, ref => this._deleteOne(ref), {
      concurrency: _constants().CONCURRENT_IO_LIMIT
    });
    const removed = this.scopeIndex.removeMany(uniqRefs);
    if (removed) await this.scopeIndex.write();
  }

  async _writeMany() {
    if (_ramda().default.isEmpty(this.objects)) return;

    _logger().default.debug(`Repository._writeMany: writing ${Object.keys(this.objects).length} objects`); // @TODO handle failures


    await (0, _pMap().default)(Object.keys(this.objects), hash => this._writeOne(this.objects[hash]), {
      concurrency: _constants().CONCURRENT_IO_LIMIT
    });

    _logger().default.debug(`Repository._writeMany: completed writing ${Object.keys(this.objects).length} objects successfully`);

    const added = this.scopeIndex.addMany(_ramda().default.values(this.objects));
    if (added) await this.scopeIndex.write();
  }
  /**
   * do not call this method directly. always call this.removeObject() and once done with all objects,
   * call this.persist()
   */


  _deleteOne(ref) {
    this.removeFromCache(ref);
    const pathToDelete = this.objectPath(ref);

    _logger().default.trace(`repository._deleteOne: deleting ${pathToDelete}`);

    return (0, _fsRemoveFile().default)(pathToDelete, true);
  }
  /**
   * always prefer this.persist().
   * this method doesn't write to scopeIndex. so using this method for ModelComponent or
   * Symlink makes the index outdated.
   */


  async _writeOne(object) {
    const contents = await object.compress();
    const options = {};
    if (this.scopeJson.groupName) options.gid = await (0, _utils().resolveGroupId)(this.scopeJson.groupName);
    const objectPath = this.objectPath(object.hash());

    _logger().default.trace(`repository._writeOne: ${objectPath}`); // Run hook to transform content pre persisting


    const transformedContent = this.onPersist(contents); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    return (0, _utils().writeFile)(objectPath, transformedContent, options);
  }

  async writeObjectsToPendingDir(objectList, pendingDir) {
    const options = {};
    if (this.scopeJson.groupName) options.gid = await (0, _utils().resolveGroupId)(this.scopeJson.groupName);
    await Promise.all(objectList.objects.map(async object => {
      const objPath = path().join(pendingDir, this.hashPath(object.ref));
      await (0, _utils().writeFile)(objPath, object.buffer, options);
    }));
  }

  async readObjectsFromPendingDir(pendingDir) {
    const refs = await this.listRefs(pendingDir);
    const objects = await Promise.all(refs.map(async ref => {
      const buffer = await _fsExtra().default.readFile(path().join(pendingDir, this.hashPath(ref)));
      return {
        ref,
        buffer
      };
    }));
    return new (_objectList().ObjectList)(objects);
  }

  hashPath(ref) {
    const hash = ref.toString();
    return path().join(hash.slice(0, 2), hash.slice(2));
  }

}

exports.default = Repository;
(0, _defineProperty2().default)(Repository, "onPostObjectsPersist", void 0);