"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = loadScope;
exports.loadScopeIfExist = loadScopeIfExist;

function path() {
  const data = _interopRequireWildcard(require("path"));

  path = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _exceptions() {
  const data = require("./exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

function _scope() {
  const data = _interopRequireDefault(require("./scope"));

  _scope = function () {
    return data;
  };

  return data;
}

function loadScope(currentPath, useCache = true) {
  if (!currentPath) currentPath = process.cwd();

  try {
    return _scope().default.load(path().resolve((0, _utils().resolveHomePath)(currentPath)), useCache);
  } catch (err) {
    return Promise.reject(err);
  }
}

async function loadScopeIfExist( // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
currentPath = process.cwd(), useCache = true) {
  try {
    return await loadScope(currentPath, useCache);
  } catch (err) {
    if (err instanceof _exceptions().ScopeNotFound) {
      return undefined;
    }

    throw err;
  }
}