"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getScopeRemotes = getScopeRemotes;
exports.fetchRemoteVersions = fetchRemoteVersions;

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _globalRemotes() {
  const data = _interopRequireDefault(require("../global-config/global-remotes"));

  _globalRemotes = function () {
    return data;
  };

  return data;
}

function _remotes() {
  const data = require("../remotes");

  _remotes = function () {
    return data;
  };

  return data;
}

function getScopeRemotes(scope) {
  function mergeRemotes(globalRemotes) {
    const globalObj = globalRemotes.toPlainObject();
    return _remotes().Remotes.load(_ramda().default.merge(globalObj, scope.scopeJson.remotes));
  }

  return _globalRemotes().default.load().then(mergeRemotes);
}

async function fetchRemoteVersions(scope, componentIds) {
  const externals = componentIds.filter(id => !id.isLocal(scope.name));
  const remotes = await getScopeRemotes(scope);
  return remotes.latestVersions(externals, scope);
}