import { BitId, BitIds } from '../bit-id';
import { ManipulateDirItem } from '../consumer/component-ops/manipulate-dir';
import ComponentWithDependencies from './component-dependencies';
import ComponentVersion, { ObjectCollector, CollectObjectsOpts } from './component-version';
import { Version } from './models';
import { ObjectItem } from './objects/object-list';
import Repository from './objects/repository';
export default class VersionDependencies implements ObjectCollector {
    component: ComponentVersion;
    dependencies: ComponentVersion[];
    sourceScope: string;
    version: Version;
    constructor(component: ComponentVersion, dependencies: ComponentVersion[], sourceScope: string, version: Version);
    get allDependencies(): ComponentVersion[];
    get allDependenciesIds(): BitIds;
    getMissingDependencies(): BitId[];
    throwForMissingDependencies(): void;
    toConsumer(repo: Repository, manipulateDirData: ManipulateDirItem[] | null | undefined): Promise<ComponentWithDependencies>;
    collectObjects(repo: Repository, clientVersion: string | null | undefined, options: CollectObjectsOpts): Promise<ObjectItem[]>;
}
export declare function multipleVersionDependenciesToConsumer(versionDependencies: VersionDependencies[], repo: Repository): Promise<ComponentWithDependencies[]>;
