"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

function _chai() {
  const data = require("chai");

  _chai = function () {
    return data;
  };

  return data;
}

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

function _checksum() {
  const data = require("./checksum");

  _checksum = function () {
    return data;
  };

  return data;
}

describe('checksum()', () => {
  describe('string()', () => {
    it('should checksum a string', () => {
      // @ts-ignore
      // eslint-disable-next-line no-undef
      (0, _chai().expect)((0, _checksum().checksum)('dshaw')).to.equal('9b8cebc0421241d087f6ab7e815285af803de7e7'); // @ts-ignore
      // eslint-disable-next-line no-undef

      (0, _chai().expect)((0, _checksum().checksum)('1234567890~!@#$%^&*()_+')).to.equal('d55303d0a19432c9689c9ebf51cee51f453b93bd');
    });
  });
  describe('checksumFile()', () => {
    it('should checksum a txt file', async () => {
      const result = await (0, _checksum().checksumFile)(_path().default.join(__dirname, './fixtures/dshaw.txt')); // @ts-ignore
      // eslint-disable-next-line no-undef

      (0, _chai().expect)(result).to.equal('9b68ce43b8693db1f08f0c900d63ee4992cacfab');
    });
    it('should checksum a gif file', async () => {
      const result = await (0, _checksum().checksumFile)(_path().default.join(__dirname, './fixtures/1px.gif')); // @ts-ignore
      // eslint-disable-next-line no-undef

      (0, _chai().expect)(result).to.equal('79fb6158b2e32b7c0b02cb6354c1cda56e91cc6f');
    });
  });
});