"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = outputFile;

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../constants");

  _constants = function () {
    return data;
  };

  return data;
}

async function outputFile({
  filePath,
  content,
  writeAutoGeneratedMessage = true,
  override = true
}) {
  if (!override && _fsExtra().default.existsSync(filePath)) {
    const fileContent = _fsExtra().default.readFileSync(filePath).toString();

    if (!fileContent.includes(_constants().AUTO_GENERATED_STAMP)) return Promise.resolve(filePath);
  }

  const data = writeAutoGeneratedMessage ? _constants().AUTO_GENERATED_MSG + content : content;
  await _fsExtra().default.outputFile(filePath, data);
  return Promise.resolve(filePath);
}