"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.promise.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = removeEmptyDir;

function _fsExtra() {
  const data = _interopRequireDefault(require("fs-extra"));

  _fsExtra = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _isDirEmpty() {
  const data = _interopRequireDefault(require("./is-dir-empty"));

  _isDirEmpty = function () {
    return data;
  };

  return data;
}

async function removeEmptyDir(dirPath) {
  let isEmpty;

  try {
    isEmpty = await (0, _isDirEmpty().default)(dirPath);
  } catch (err) {
    if (err.code === 'ENOENT') return false;
    throw err;
  }

  if (isEmpty) {
    _logger().default.info(`remove-empty-dir, deleting ${dirPath}`);

    await _fsExtra().default.remove(dirPath);
    return true;
  }

  return false;
}